SystemOrganization addCategory: #'SeasideLocalisation-Core'!

WADynamicVariable subclass: #SLCurrentLocale
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SeasideLocalisation-Core'!

!SLCurrentLocale commentStamp: 'IlariLiukko 12/16/2011 13:56' prior: 0!
CurrentLocale is WADynamicVariable used to store curren locale used to render userinterface. If it is not set it returns the images locale (Locale current).!

!SLCurrentLocale class methodsFor: 'as yet unclassified' stamp: 'IlariLiukko 12/22/2011 12:20'!
value
	^ super value
		ifNil: [ 
			WACurrentSession value
				ifNil: [ Locale current ]
				ifNotNilDo: [ :nonNilSession | nonNilSession properties at: #locale ifAbsent: [ Locale current ] ] ]! !

!SLCurrentLocale class methodsFor: 'as yet unclassified' stamp: 'IlariLiukko 12/21/2011 15:18'!
value: aLocale
	WACurrentSession value ifNotNil: [ :session | session properties at: #locale put: aLocale ]! !

WAComponent subclass: #SLSelectLocaleComponent
	instanceVariableNames: 'availableLocales'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SeasideLocalisation-Core'!

!SLSelectLocaleComponent methodsFor: 'as yet unclassified' stamp: 'IlariLiukko 12/21/2011 14:16'!
availableLocales
	^ availableLocales ifNil: [ Locale knownLocales ]! !

!SLSelectLocaleComponent methodsFor: 'accessing' stamp: 'IlariLiukko 12/21/2011 14:19'!
availableLocales: anObject
	availableLocales := anObject! !

!SLSelectLocaleComponent methodsFor: 'as yet unclassified' stamp: 'KariPatana 1/9/2012 14:29'!
renderContentOn: html
	html div
		id: 'languageSelection';
		with: [ 
					html text: '['.
					self availableLocales
						do: [ :locale | 
							html anchor
								callback: [ self selectedLocale: locale ];
								with: locale isoLanguage ]
						separatedBy: [ html text: ' | ' ].
					html text: ']' ]! !

!SLSelectLocaleComponent methodsFor: 'as yet unclassified' stamp: 'IlariLiukko 12/21/2011 14:56'!
selectedLocale
	^SLCurrentLocale value.! !

!SLSelectLocaleComponent methodsFor: 'as yet unclassified' stamp: 'IlariLiukko 12/21/2011 14:54'!
selectedLocale: aLocale
	SLCurrentLocale value: aLocale.! !

!String methodsFor: '*seasidelocalisation-core' stamp: 'IlariLiukko 12/21/2011 13:28'!
translate
	^ SLTranslationProxy for: self.! !

GetTextExporter subclass: #SLGetTextExporter
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SeasideLocalisation-Core'!

!SLGetTextExporter methodsFor: 'as yet unclassified' stamp: 'IlariLiukko 12/22/2011 09:03'!
appendTranslations: domains 
	super appendTranslations: domains.
	self appendStringReceivers: #translate into: domains
! !

WARequestFilter subclass: #SLBrowserLocaleFilter
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SeasideLocalisation-Core'!

!SLBrowserLocaleFilter methodsFor: 'as yet unclassified' stamp: 'IlariLiukko 12/22/2011 10:02'!
acceptLocales: aWARequestContext
	^ aWARequestContext request acceptLanguage
		collect: [ :waAcceptLanguage | Locale localeID: (LocaleID isoLanguage: waAcceptLanguage value language isoCountry: waAcceptLanguage value country) ]! !

!SLBrowserLocaleFilter methodsFor: 'as yet unclassified' stamp: 'IlariLiukko 12/22/2011 10:01'!
handleFiltered: aRequestContext
	| locales |
	locales := self acceptLocales: aRequestContext.
	SLCurrentLocale
		use: (self selectLocale: locales)
		during: [ 
			Transcript
				show: SLCurrentLocale value;
				cr.
			super handleFiltered: aRequestContext ]! !

!SLBrowserLocaleFilter methodsFor: 'as yet unclassified' stamp: 'IlariLiukko 12/22/2011 09:49'!
selectLocale: anArray 
	^ anArray first.! !

Object subclass: #SLStringTemplateParser
	instanceVariableNames: 'parseString'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SeasideLocalisation-Core'!

!SLStringTemplateParser class methodsFor: 'as yet unclassified' stamp: 'IlariLiukko 12/23/2011 08:49'!
parse: aByteString 
	^ self new parse: aByteString; yourself.
! !

!SLStringTemplateParser methodsFor: 'as yet unclassified' stamp: 'IlariLiukko 12/23/2011 08:49'!
collectWithParameters: anArray 
	self shouldBeImplemented.! !

!SLStringTemplateParser methodsFor: 'as yet unclassified' stamp: 'KariPatana 1/2/2012 13:01'!
parse: aByteString
	parseString := aByteString.! !

Object subclass: #SLTranslationProxy
	instanceVariableNames: 'stringObject domain parameters'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SeasideLocalisation-Core'!

!SLTranslationProxy class methodsFor: 'as yet unclassified' stamp: 'IlariLiukko 12/19/2011 13:19'!
for: aString
	| callerClass |
	callerClass := thisContext sender sender methodClass.
	^ self new
		stringObject: aString;
		domain: (TextDomainManager domainForClass:callerClass);
		yourself! !

!SLTranslationProxy methodsFor: 'as yet unclassified' stamp: 'IlariLiukko 12/22/2011 14:21'!
<== aStringOrArray
	| array |
	array := (aStringOrArray isString or: [ aStringOrArray isArray not])
		ifTrue: [ Array with: aStringOrArray ]
		ifFalse: [ aStringOrArray ].
	parameters := array.
	^ self! !

!SLTranslationProxy methodsFor: 'as yet unclassified' stamp: 'IlariLiukko 12/22/2011 10:18'!
= anObject
	^ [ stringObject = anObject stringObject ] onDNU: #stringObject do: [ stringObject = anObject ]! !

!SLTranslationProxy methodsFor: 'as yet unclassified' stamp: 'IlariLiukko 12/19/2011 12:39'!
asString
	^self translatedString! !

!SLTranslationProxy methodsFor: 'as yet unclassified' stamp: 'KariPatana 12/28/2011 13:43'!
at: index
	^ self translatedString at: index! !

!SLTranslationProxy methodsFor: 'as yet unclassified' stamp: 'IlariLiukko 12/19/2011 12:28'!
doesNotUnderstand: aMessage
	^ aMessage sendTo: self translatedString! !

!SLTranslationProxy methodsFor: 'accessing' stamp: 'IlariLiukko 12/19/2011 12:43'!
domain
	^ domain! !

!SLTranslationProxy methodsFor: 'accessing' stamp: 'IlariLiukko 12/19/2011 12:43'!
domain: anObject
	domain := anObject! !

!SLTranslationProxy methodsFor: 'as yet unclassified' stamp: 'IlariLiukko 12/22/2011 14:28'!
evaluateExpression: aString parameters: aCollection 
	"private - evaluate the expression aString with  
	aCollection as the parameters and answer the  
	evaluation result as an string"
	| index |
	index := ('0' , aString) asNumber.

	index isZero
		ifTrue: [^ '[invalid subscript: {1}]' format: {aString}].

	index > aCollection size
		ifTrue: [^ '[subscript is out of bounds: {1}]' format: {aString}].

	^ (aCollection at: index)! !

!SLTranslationProxy methodsFor: 'as yet unclassified' stamp: 'IlariLiukko 12/22/2011 14:10'!
getEnclosedExpressionFrom: aStream 
	"private - get the expression enclosed between '{' and 
	'}' and remove all the characters from the stream"
	| result currentChar |
	result := String new writeStream.

	[aStream atEnd 
		or: [(currentChar := aStream next) == $}]]
		whileFalse: [result nextPut: currentChar].

	^ result contents withBlanksTrimmed! !

!SLTranslationProxy methodsFor: 'as yet unclassified' stamp: 'IlariLiukko 12/22/2011 10:11'!
hash
	^ stringObject hash! !

!SLTranslationProxy methodsFor: 'as yet unclassified' stamp: 'IlariLiukko 12/19/2011 12:35'!
printOn: aStream
	self translatedString printOn: aStream! !

!SLTranslationProxy methodsFor: 'as yet unclassified' stamp: 'IlariLiukko 12/22/2011 14:36'!
renderOn: html
	| result stream |
	result := String new writeStream.
	stream := self translation readStream.
	[ stream atEnd ]
		whileFalse: [ 
			| currentChar |
			currentChar := stream next.
			currentChar == ${
				ifTrue: [ 
					| expression |
					expression := self getEnclosedExpressionFrom: stream.
					result contents renderOn: html.
					result reset.
					(self evaluateExpression: expression parameters: parameters) renderOn: html ]
				ifFalse: [ 
					currentChar == $\
						ifTrue: [ 
							stream atEnd
								ifFalse: [ result nextPut: stream next ] ]
						ifFalse: [ result nextPut: currentChar ] ] ].
	result contents renderOn: html! !

!SLTranslationProxy methodsFor: 'as yet unclassified' stamp: 'KariPatana 12/28/2011 13:41'!
size
	^ self translatedString size! !

!SLTranslationProxy methodsFor: 'accessing' stamp: 'IlariLiukko 12/19/2011 12:29'!
stringObject
	^ stringObject! !

!SLTranslationProxy methodsFor: 'accessing' stamp: 'IlariLiukko 12/19/2011 12:29'!
stringObject: anObject
	stringObject := anObject! !

!SLTranslationProxy methodsFor: 'as yet unclassified' stamp: 'IlariLiukko 12/22/2011 14:13'!
translatedString
	| translated |
	translated := self translation.
	^ parameters ifNil: [ translated ] ifNotNilDo: [ :nonNilParameters | translated format: nonNilParameters ]! !

!SLTranslationProxy methodsFor: 'as yet unclassified' stamp: 'IlariLiukko 12/22/2011 14:12'!
translation
	| currentLocale |
	currentLocale := SLCurrentLocale value.
	^ NaturalLanguageTranslator translate: stringObject toLocale: currentLocale localeID inDomain: domain.
! !
